part of datepicker;

enum DateRangePickerSelectionMode { single, multiple, range, multiRange }

enum DateRangePickerView { month, year, decade, century }

enum DateRangePickerSelectionShape { circle, rectangle }

enum DateRangePickerNavigationDirection { vertical, horizontal }

/// args to update the required properties from picker state to it's children's
class _PickerStateArgs {
  DateTime _currentDate;
  List<DateTime> _currentViewVisibleDates;
  DateTime _selectedDate;
  List<DateTime> _selectedDates;
  PickerDateRange _selectedRange;
  List<PickerDateRange> _selectedRanges;
  DateRangePickerView _view;
}

/// holds the view changed event arguments
class DateRangePickerViewChangedArgs {
  DateRangePickerViewChangedArgs(this.visibleDateRange, this.view);

  final PickerDateRange visibleDateRange;
  final DateRangePickerView view;
}

/// holds the selection changed event arguments
class DateRangePickerSelectionChangedArgs {
  DateRangePickerSelectionChangedArgs(this.value);

  final dynamic value;
}

class PickerDateRange {
  PickerDateRange(this.startDate, this.endDate);

  final DateTime startDate;
  final DateTime endDate;
}
