part of datepicker;

class DateRangePickerHeaderStyle {
  DateRangePickerHeaderStyle(
      {this.textAlign = TextAlign.left, this.backgroundColor, this.textStyle});

  final TextStyle textStyle;

  final TextAlign textAlign;

  final Color backgroundColor;

  @override
  bool operator ==(dynamic other) {
    if (identical(this, other)) {
      return true;
    }
    if (other.runtimeType != runtimeType) {
      return false;
    }

    final DateRangePickerHeaderStyle otherStyle = other;
    return otherStyle.textStyle == textStyle &&
        otherStyle.textAlign == textAlign &&
        otherStyle.backgroundColor == backgroundColor;
  }

  @override
  int get hashCode {
    return hashValues(
      textStyle,
      textAlign,
      backgroundColor,
    );
  }
}

class DateRangePickerViewHeaderStyle {
  DateRangePickerViewHeaderStyle({this.backgroundColor, this.textStyle});

  final Color backgroundColor;

  final TextStyle textStyle;

  @override
  bool operator ==(dynamic other) {
    if (identical(this, other)) {
      return true;
    }
    if (other.runtimeType != runtimeType) {
      return false;
    }

    final DateRangePickerViewHeaderStyle otherStyle = other;
    return otherStyle.backgroundColor == backgroundColor &&
        otherStyle.textStyle == textStyle;
  }

  @override
  int get hashCode {
    return hashValues(
      backgroundColor,
      textStyle,
    );
  }
}

class DateRangePickerMonthViewSettings {
  DateRangePickerMonthViewSettings(
      {this.numberOfWeeksInView = 6,
      this.firstDayOfWeek = 7,
      this.dayFormat = 'EE',
      this.viewHeaderHeight = 30,
      this.selectionRadius,
      this.showTrailingAndLeadingDates = false,
      DateRangePickerViewHeaderStyle viewHeaderStyle,
      this.enableSwipeSelection = true,
      this.blackoutDates,
      this.specialDates,
      List<int> weekendDays})
      : viewHeaderStyle = viewHeaderStyle ?? DateRangePickerViewHeaderStyle(),
        weekendDays = weekendDays ?? <int>[6, 7];

  final String dayFormat;

  final int numberOfWeeksInView;

  final bool enableSwipeSelection;

  final int firstDayOfWeek;

  final DateRangePickerViewHeaderStyle viewHeaderStyle;

  final double viewHeaderHeight;

  final double selectionRadius;

  final bool showTrailingAndLeadingDates;

  final List<DateTime> blackoutDates;

  final List<DateTime> specialDates;

  final List<int> weekendDays;

  @override
  bool operator ==(dynamic other) {
    if (identical(this, other)) {
      return true;
    }
    if (other.runtimeType != runtimeType) {
      return false;
    }

    final DateRangePickerMonthViewSettings otherStyle = other;
    return otherStyle.dayFormat == dayFormat &&
        otherStyle.numberOfWeeksInView == numberOfWeeksInView &&
        otherStyle.firstDayOfWeek == firstDayOfWeek &&
        otherStyle.viewHeaderStyle == viewHeaderStyle &&
        otherStyle.viewHeaderHeight == viewHeaderHeight &&
        otherStyle.selectionRadius == selectionRadius &&
        otherStyle.showTrailingAndLeadingDates == showTrailingAndLeadingDates &&
        otherStyle.blackoutDates == blackoutDates &&
        otherStyle.specialDates == specialDates &&
        otherStyle.weekendDays == weekendDays &&
        otherStyle.enableSwipeSelection == enableSwipeSelection;
  }

  @override
  int get hashCode {
    return hashValues(
        dayFormat,
        firstDayOfWeek,
        viewHeaderStyle,
        enableSwipeSelection,
        viewHeaderHeight,
        selectionRadius,
        showTrailingAndLeadingDates,
        numberOfWeeksInView,
        specialDates,
        blackoutDates,
        weekendDays);
  }
}

class DateRangePickerYearCellStyle {
  DateRangePickerYearCellStyle(
      {this.textStyle,
      this.todayTextStyle,
      this.leadingDatesTextStyle,
      this.disabledDatesTextStyle,
      this.cellDecoration,
      this.todayCellDecoration,
      this.disabledDatesDecoration,
      this.leadingDatesDecoration});

  final TextStyle textStyle;

  final TextStyle todayTextStyle;

  final TextStyle leadingDatesTextStyle;

  final TextStyle disabledDatesTextStyle;

  final Decoration disabledDatesDecoration;

  final Decoration cellDecoration;

  final Decoration todayCellDecoration;

  final Decoration leadingDatesDecoration;

  @override
  bool operator ==(dynamic other) {
    if (identical(this, other)) {
      return true;
    }
    if (other.runtimeType != runtimeType) {
      return false;
    }

    final DateRangePickerYearCellStyle otherStyle = other;
    return otherStyle.textStyle == textStyle &&
        otherStyle.todayTextStyle == todayTextStyle &&
        otherStyle.leadingDatesTextStyle == leadingDatesTextStyle &&
        otherStyle.disabledDatesDecoration == disabledDatesDecoration &&
        otherStyle.cellDecoration == cellDecoration &&
        otherStyle.todayCellDecoration == todayCellDecoration &&
        otherStyle.leadingDatesDecoration == leadingDatesDecoration &&
        otherStyle.disabledDatesTextStyle == disabledDatesTextStyle;
  }

  @override
  int get hashCode {
    return hashValues(
        textStyle,
        todayTextStyle,
        leadingDatesTextStyle,
        disabledDatesTextStyle,
        disabledDatesDecoration,
        cellDecoration,
        todayCellDecoration,
        leadingDatesDecoration);
  }
}

class DateRangePickerMonthCellStyle {
  DateRangePickerMonthCellStyle(
      {this.selectionColor,
      this.startRangeSelectionColor,
      this.endRangeSelectionColor,
      this.rangeSelectionColor,
      this.textStyle,
      this.todayTextStyle,
      this.trailingDatesTextStyle,
      this.leadingDatesTextStyle,
      this.selectionTextStyle,
      this.disabledDatesTextStyle,
      this.blackoutDateTextStyle,
      this.weekendTextStyle,
      this.specialDatesTextStyle,
      this.specialDatesDecoration,
      this.blackoutDatesDecoration,
      this.cellDecoration,
      this.todayCellDecoration,
      this.disabledDatesDecoration,
      this.trailingDatesDecoration,
      this.leadingDatesDecoration,
      this.rangeTextStyle,
      this.weekendDatesDecoration});

  final TextStyle textStyle;

  final TextStyle todayTextStyle;

  final TextStyle trailingDatesTextStyle;

  final TextStyle leadingDatesTextStyle;

  final TextStyle disabledDatesTextStyle;

  final TextStyle selectionTextStyle;

  final TextStyle rangeTextStyle;

  final TextStyle blackoutDateTextStyle;

  final TextStyle weekendTextStyle;

  final TextStyle specialDatesTextStyle;

  final Decoration specialDatesDecoration;

  final Decoration weekendDatesDecoration;

  final Decoration blackoutDatesDecoration;

  final Decoration disabledDatesDecoration;

  final Decoration cellDecoration;

  final Decoration todayCellDecoration;

  final Decoration trailingDatesDecoration;

  final Decoration leadingDatesDecoration;

  final Color selectionColor;

  final Color startRangeSelectionColor;

  final Color rangeSelectionColor;

  final Color endRangeSelectionColor;

  @override
  bool operator ==(dynamic other) {
    if (identical(this, other)) {
      return true;
    }
    if (other.runtimeType != runtimeType) {
      return false;
    }

    final DateRangePickerMonthCellStyle otherStyle = other;
    return otherStyle.textStyle == textStyle &&
        otherStyle.todayTextStyle == todayTextStyle &&
        otherStyle.trailingDatesTextStyle == trailingDatesTextStyle &&
        otherStyle.leadingDatesTextStyle == leadingDatesTextStyle &&
        otherStyle.selectionTextStyle == selectionTextStyle &&
        otherStyle.blackoutDateTextStyle == blackoutDateTextStyle &&
        otherStyle.weekendTextStyle == weekendTextStyle &&
        otherStyle.selectionColor == selectionColor &&
        otherStyle.startRangeSelectionColor == startRangeSelectionColor &&
        otherStyle.endRangeSelectionColor == endRangeSelectionColor &&
        otherStyle.specialDatesTextStyle == specialDatesTextStyle &&
        otherStyle.specialDatesDecoration == specialDatesDecoration &&
        otherStyle.weekendDatesDecoration == weekendDatesDecoration &&
        otherStyle.blackoutDatesDecoration == blackoutDatesDecoration &&
        otherStyle.disabledDatesDecoration == disabledDatesDecoration &&
        otherStyle.cellDecoration == cellDecoration &&
        otherStyle.todayCellDecoration == todayCellDecoration &&
        otherStyle.trailingDatesDecoration == trailingDatesDecoration &&
        otherStyle.rangeTextStyle == rangeTextStyle &&
        otherStyle.rangeSelectionColor == rangeSelectionColor &&
        otherStyle.leadingDatesDecoration == leadingDatesDecoration &&
        otherStyle.disabledDatesTextStyle == disabledDatesTextStyle;
  }

  @override
  int get hashCode {
    return hashList(<Object>[
      textStyle,
      todayTextStyle,
      trailingDatesTextStyle,
      leadingDatesTextStyle,
      disabledDatesTextStyle,
      specialDatesDecoration,
      weekendDatesDecoration,
      blackoutDatesDecoration,
      disabledDatesDecoration,
      cellDecoration,
      todayCellDecoration,
      trailingDatesDecoration,
      leadingDatesDecoration,
      specialDatesTextStyle,
      selectionTextStyle,
      blackoutDateTextStyle,
      weekendTextStyle,
      selectionColor,
      startRangeSelectionColor,
      endRangeSelectionColor,
      rangeSelectionColor,
      rangeTextStyle
    ]);
  }
}
